diff -urN qmail-1.03-vanilla/qmail-remote.c qmail-1.03-md24/qmail-remote.c
--- qmail-1.03-vanilla/qmail-remote.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/qmail-remote.c	2007-07-19 23:01:53.000000000 +0200
@@ -310,118 +833,264 @@
 
 void getcontrols()
 {
-  if (control_init() == -1) temp_control();
-  if (control_readint(&timeout,"control/timeoutremote") == -1) temp_control();
-  if (control_readint(&timeoutconnect,"control/timeoutconnect") == -1)
+  if (control_init() == -1)
     temp_control();
-  if (control_rldef(&helohost,"control/helohost",1,(char *) 0) != 1)
-    temp_control();
-  switch(control_readfile(&routes,"control/smtproutes",0)) {
+
+  if (control_readint(&timeoutconnect,"control/timeoutconnect") == -1) temp_control();
+  if (control_readint(&timeout,"control/timeoutremote") == -1) temp_control();
+  if (control_rldef(&helohost,"control/helohost",1,(char *) 0) != 1) temp_control();
+
+  switch (control_readfile(&routes,"control/smtproutes",0)) {
+    case -1:
+      temp_control();
+      break;
+    case 0:
+      if (!constmap_init(&maproutes,"",0,1)) temp_nomem();
+      break;
+    case 1:
+      if (!constmap_init(&maproutes,routes.s,routes.len,1)) temp_nomem();
+      break;
+  }
+
+  switch (control_readfile(&relays,"control/smtprelays",0)) {
+    case -1:
+      temp_control();
+      break;
+    case 0:
+      if (!constmap_init(&maprelays,"",0,1)) temp_nomem();
+      break;
+    case 1:
+      if (!constmap_init(&maprelays,relays.s,relays.len,1)) temp_nomem();
+      break;
+  }
+
+  switch (control_readfile(&qroutes,"control/qmtproutes",0)) {
     case -1:
       temp_control();
+      break;
     case 0:
-      if (!constmap_init(&maproutes,"",0,1)) temp_nomem(); break;
+      if (!constmap_init(&mapqroutes,"",0,1)) temp_nomem();
+      break;
     case 1:
-      if (!constmap_init(&maproutes,routes.s,routes.len,1)) temp_nomem(); break;
+      if (!constmap_init(&mapqroutes,qroutes.s,qroutes.len,1)) temp_nomem();
+      break;
+  }
+
+  switch (control_readline(&outgoingip,"control/outgoingip")) {
+    case -1:
+      if (errno == error_nomem) temp_nomem();
+      temp_control();
+      break;
+    case 0:
+      if (!stralloc_copys(&outgoingip, "0.0.0.0")) temp_nomem();
+      break;
   }
+  if (str_equal(outgoingip.s, "0.0.0.0")) {
+    outip.d[0]=outip.d[1]=outip.d[2]=outip.d[3]=(unsigned long)0;
+  } else if (!ip_scan(outgoingip.s, &outip)) temp_noip();
+
+  /* logging */
+  if (control_readint(&ctl_log_fd,"control/log/remote_fd") == -1) temp_control();
+  if (ctl_log_fd  < 0) ctl_log_fd=0;
+  if (ctl_log_fd) subfderr->fd = ctl_log_fd;
+
+  return;
 }
 
-void main(argc,argv)
-int argc;
-char **argv;
+
+int main(int argc, char **argv)
 {
   static ipalloc ip = {0};
-  int i;
-  unsigned long random;
+  unsigned long random, prefme;
   char **recips;
-  unsigned long prefme;
-  int flagallaliases;
-  int flagalias;
-  char *relayhost;
- 
+  char *relayhost=0, *relayuser=0;
+  int flagallaliases, flagalias, flagqmtp=0;
+  int i;
+
   sig_pipeignore();
-  if (argc < 4) perm_usage();
+  if (argc < 5) perm_usage();
   if (chdir(auto_qmail) == -1) temp_chdir();
   getcontrols();
- 
- 
+
   if (!stralloc_copys(&host,argv[1])) temp_nomem();
- 
-  relayhost = 0;
-  for (i = 0;i <= host.len;++i)
+  if (!stralloc_copys(&authuser,"")) temp_nomem();
+  if (!stralloc_copys(&authpass,"")) temp_nomem();
+  if (!stralloc_copys(&authtype,"")) temp_nomem();
+  addrmangle(&sender, argv[2], &flagalias, 0);
+
+/*
+ * smtprelays: mailuser@host.domain:virtual-relay|authuser|authpass|authtype
+ *             mailuser@host.domain:virtual-relay
+ *             mailuser@host.domain:relaysmtp|authuser|authpass|authtype
+ *
+ * smtproutes: virtual-relay:host.domain
+ *             virtual-relay:host.domain:port
+ *             host.domain:host2.domain
+ *
+ * qmtproutes: virtual-relay:host.domain
+ *             virtual-relay:host.domain:port
+ *             host.domain:host2.domain
+ */
+
+  /* control/smtprelays */
+  for (i = 0; i <= sender.len; ++i)
+    if ((i == 0) || (i == sender.len) || (sender.s[i] == '.'))
+      if ((relayuser = constmap(&maprelays, sender.s + i, sender.len - i))) break;
+  if (relayuser && !*relayuser) relayuser = 0;
+
+  if (relayuser) {
+    /* V1|mcmilk|password2 */
+    /* V2|mcmilk|password2|cram-md5 */
+    char *x=relayuser, *y;
+
+    y=x;
+    /* forwards also non password users to virtual servers in smtproutes */
+    while (*++x) if (*x == '|' || !*x) break;
+    if (!stralloc_copyb(&host, y, x-y)) temp_nomem();
+
+    y=x;
+    if (*x == '|') while (*++x) if (*x == '|' || !*x) {
+      if (!stralloc_copyb(&authuser, y+1, x-y-1)) temp_nomem();
+      authuser.s[authuser.len]=0; break;
+    }
+
+    y=x;
+    if (*x == '|') while (*++x) if (*x == '|' || !*x) {
+      if (!stralloc_copyb(&authpass, y+1, x-y-1)) temp_nomem();
+      authpass.s[authpass.len]=0; break;
+    }
+
+    /* authuser is given, so we need a password! */
+    if (authuser.len && !authpass.len) temp_control();
+    if (authuser.len && authpass.len) needauth=1;
+
+    y=x;
+    /* optional authtype, so we don't have to parse the ehlo resp. */
+    if (*x == '|') {
+      while (*++x);
+      if (!stralloc_copyb(&authtype, y+1, x-y-1)) temp_nomem();
+    }
+ }
+#if 0
+    //if (relayhost) { doname(); Log("DEBUG1: relayhost=");  Log(relayhost); Log("\n"); }
+    //if (relayuser) { doname(); Log("DEBUG1: relayuser=");  Log(relayuser); Log("\n"); }
+    doname(); Log("DEBUG1: host=");       Logn(host.s, host.len); Log("\n");
+    doname(); Log("DEBUG1: authuser=");   Logn(authuser.s, authuser.len); Log("\n");
+    doname(); Log("DEBUG1: authpass=");   Logn(authpass.s, authpass.len); Log("\n");
+    doname(); Log("DEBUG1: authtype=");   Logn(authtype.s, authtype.len); Log("\n");
+    flush();
+#endif
+
+  /* control/smtproutes */
+  for (i = 0; i <= host.len; ++i)
     if ((i == 0) || (i == host.len) || (host.s[i] == '.'))
-      if (relayhost = constmap(&maproutes,host.s + i,host.len - i))
-        break;
+      if ((relayhost = constmap(&maproutes,host.s + i,host.len - i))) break;
   if (relayhost && !*relayhost) relayhost = 0;
- 
+
   if (relayhost) {
     i = str_chr(relayhost,':');
     if (relayhost[i]) {
-      scan_ulong(relayhost + i + 1,&port);
+      scan_ulong(relayhost + i + 1, &smtp_port);
       relayhost[i] = 0;
     }
     if (!stralloc_copys(&host,relayhost)) temp_nomem();
+  } else {
+    /* control/qmtproutes */
+    for (i = 0; i <= host.len; ++i)
+      if ((i == 0) || (i == host.len) || (host.s[i] == '.'))
+        if ((relayhost = constmap(&mapqroutes,host.s + i,host.len - i))) break;
+    if (relayhost && !*relayhost) relayhost = 0;
+
+    if (relayhost) {
+      i = str_chr(relayhost,':');
+      if (relayhost[i]) {
+        scan_ulong(relayhost + i + 1, &qmtp_port);
+        relayhost[i] = 0;
+      }
+      if (!stralloc_copys(&host,relayhost)) temp_nomem();
+      flagqmtp=1;
+    }
   }
 
+#if 0
+    //if (relayhost) { doname(); Log("DEBUG2: relayhost=");  Log(relayhost); Log("\n"); }
+    //if (relayuser) { doname(); Log("DEBUG2: relayuser=");  Log(relayuser); Log("\n"); }
+    doname(); Log("DEBUG2: host=");     Logn(host.s, host.len); Log("\n");
+    doname(); Log("DEBUG2: authuser="); Logn(authuser.s, authuser.len); Log("\n");
+    doname(); Log("DEBUG2: authpass="); Logn(authpass.s, authpass.len); Log("\n");
+    doname(); Log("DEBUG2: authtype="); Logn(authtype.s, authtype.len); Log("\n");
+    flush();
+#endif
 
-  addrmangle(&sender,argv[2],&flagalias,0);
- 
   if (!saa_readyplus(&reciplist,0)) temp_nomem();
   if (ipme_init() != 1) temp_oserr();
- 
+
   flagallaliases = 1;
-  recips = argv + 3;
+  recips = argv + 4;
   while (*recips) {
     if (!saa_readyplus(&reciplist,1)) temp_nomem();
     reciplist.sa[reciplist.len] = sauninit;
-    addrmangle(reciplist.sa + reciplist.len,*recips,&flagalias,!relayhost);
+    addrmangle(reciplist.sa + reciplist.len, *recips, &flagalias, !relayhost);
     if (!flagalias) flagallaliases = 0;
     ++reciplist.len;
     ++recips;
   }
 
- 
   random = now() + (getpid() << 16);
-  switch (relayhost ? dns_ip(&ip,&host) : dns_mxip(&ip,&host,random)) {
-    case DNS_MEM: temp_nomem();
+  switch (relayhost ? dns_ip(&ip,&host) : dns_mxip(&ip, &host, random)) {
+    case DNS_MEM:  temp_nomem();
     case DNS_SOFT: temp_dns();
     case DNS_HARD: perm_dns();
-    case 1:
-      if (ip.len <= 0) temp_dns();
+    case 1: if (ip.len <= 0) temp_dns();
   }
- 
+
   if (ip.len <= 0) perm_nomx();
- 
+
   prefme = 100000;
   for (i = 0;i < ip.len;++i)
     if (ipme_is(&ip.ix[i].ip))
       if (ip.ix[i].pref < prefme)
         prefme = ip.ix[i].pref;
- 
+
   if (relayhost) prefme = 300000;
   if (flagallaliases) prefme = 500000;
- 
+
   for (i = 0;i < ip.len;++i)
-    if (ip.ix[i].pref < prefme)
-      break;
- 
-  if (i >= ip.len)
-    perm_ambigmx();
- 
-  for (i = 0;i < ip.len;++i) if (ip.ix[i].pref < prefme) {
+    if (ip.ix[i].pref < prefme) break;
+  if (i >= ip.len) perm_ambigmx();
+
+  for (i = 0; i < ip.len; ++i)
+  if (ip.ix[i].pref < prefme) {
     if (tcpto(&ip.ix[i].ip)) continue;
- 
+
     smtpfd = socket(AF_INET,SOCK_STREAM,0);
     if (smtpfd == -1) temp_oserr();
- 
-    if (timeoutconn(smtpfd,&ip.ix[i].ip,(unsigned int) port,timeoutconnect) == 0) {
+
+    /* 1. try qmtp */
+    if (flagqmtp || qmtp_priority(ip.ix[i].pref)) {
+      if (timeoutconn(smtpfd, &ip.ix[i].ip, &outip,
+        (unsigned int) qmtp_port, timeoutconnect) == 0) {
+        tcpto_err(&ip.ix[i].ip,0);
+        partner = ip.ix[i].ip;
+        qmtp(); /* does normally not return */
+      }
+      close(smtpfd);
+      smtpfd = socket(AF_INET,SOCK_STREAM,0);
+      if (smtpfd == -1) temp_oserr();
+    }
+
+    /* 2. try smtp, for all possible mx records! */
+    if (timeoutconn(smtpfd, &ip.ix[i].ip, &outip,
+      (unsigned int) smtp_port, timeoutconnect) == 0) {
       tcpto_err(&ip.ix[i].ip,0);
       partner = ip.ix[i].ip;
-      smtp(); /* does not return */
+      partner_fqdn = ip.ix[i].fqdn;
+      smtp(argv[3]); /* next MX is to be tried */
     }
     tcpto_err(&ip.ix[i].ip,errno == error_timeout);
     close(smtpfd);
   }
-  
+
   temp_noconn();
+  return 111; /* gcc */
 }
diff -urN qmail-1.03-vanilla/qmail-rspawn.c qmail-1.03-md24/qmail-rspawn.c
--- qmail-1.03-vanilla/qmail-rspawn.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/qmail-rspawn.c	2007-07-19 20:56:22.000000000 +0200
@@ -4,6 +4,7 @@
 #include "exit.h"
 #include "fork.h"
 #include "error.h"
+#include "fmt.h"
 #include "tcpto.h"
 
 void initialize(argc,argv)
@@ -77,18 +78,20 @@
     }
 }
 
-int spawn(fdmess,fdout,s,r,at)
-int fdmess; int fdout;
-char *s; char *r; int at;
+int
+spawn(int fdmess, int fdout, unsigned long msgsize, char *s, char *r, int at)
 {
  int f;
- char *(args[5]);
+ char *(args[6]);
+ char size_buf[FMT_ULONG];
 
+ size_buf[fmt_ulong(size_buf, msgsize)] = 0;
  args[0] = "qmail-remote";
  args[1] = r + at + 1;
  args[2] = s;
- args[3] = r;
- args[4] = 0;
+ args[3] = size_buf;
+ args[4] = r;
+ args[5] = 0;
 
  if (!(f = vfork()))
   {
diff -urN qmail-1.03-vanilla/qmail-sasl.c qmail-1.03-md24/qmail-sasl.c
--- qmail-1.03-vanilla/qmail-sasl.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-md24/qmail-sasl.c	2007-08-12 10:42:00.000000000 +0200
@@ -0,0 +1,429 @@
+
+#include <string.h>
+#include "qmail-sasl.h"
+
+const char hextab[]="0123456789abcdef";
+char *sasl[] = { "LOGIN","PLAIN","CRAM-MD5","CRAM-SHA1","CRAM-RIPEMD","DIGEST-MD5" };
+char unique[FMT_ULONG + FMT_ULONG + 3];
+
+int auth_for=0; /* MODE_POPUP / MODE_SMTPD */
+
+substdio ssauth;
+stralloc auth = {0}; /* incoming from client */
+stralloc user = {0}; /* username */
+stralloc pass = {0}; /* password */
+stralloc resp = {0}; /* response */
+stralloc slop = {0};
+
+authcmd_t authcmds[] = {
+  { "login",           auth_login }
+, { "plain",           auth_plain }
+, { "cram-md5",        auth_cram_md5 }
+, { "cram-sha1",       auth_cram_sha1 }
+, { "cram-ripemd",     auth_cram_rmd }
+, { "digest-md5",      auth_digest_md5 }
+, { 0,                 err_noauth }
+};
+
+int authgetl(void) {
+  int i;
+
+  if (!stralloc_copys(&auth, "")) die_nomem();
+  for (;;) {
+    if (!stralloc_readyplus(&auth,1)) die_nomem();
+    i = substdio_get(&ssin,auth.s + auth.len,1);
+    if (i != 1) die_read();
+    if (auth.s[auth.len] == '\n') break;
+    ++auth.len;
+  }
+
+  if (auth.len > 0) if (auth.s[auth.len - 1] == '\r') --auth.len;
+  auth.s[auth.len] = 0;
+  doname();Log("C: ");Log(auth.s);Log("\n");
+
+  if (*auth.s == '*' && *(auth.s + 1) == 0) { return ERR_AUTH_ABORT; }
+  if (auth.len == 0) { return ERR_AUTH_INPUT; }
+
+  return auth.len;
+}
+
+/* method:
+ * 0 = login / plain / cram
+ * 1 = digest-md5
+ */
+#define METHOD_DIGEST_MD5 1
+int authenticate(int method)
+{
+  char upbuf[512];
+  int child, wstat, pi[2];
+
+  if (!stralloc_0(&user)) die_nomem();
+  if (!stralloc_0(&pass)) die_nomem();
+  if (!stralloc_0(&resp)) die_nomem();
+
+  if (env_get("DEBUG_AUTH")) {
+    Log("SASL user:");Log(user.s);Log("\n");
+    Log("SASL pass:");Log(pass.s);Log("\n");
+    Log("SASL resp:");Log(resp.s);Log("\n");
+  }
+  flush();
+
+  /* if (fd_copy(2,1) == -1) die_pipe(); */
+  close(3);
+  if (pipe(pi) == -1) die_pipe();
+  if (pi[0] != 3) die_pipe();
+  switch (child = fork()) {
+    case -1:
+      die_fork();
+      break;
+    case 0:
+      close(pi[1]);
+      sig_pipedefault();
+      execvp(*childargs, childargs);
+      break;
+  }
+  close(pi[0]);
+
+  substdio_fdbuf(&ssauth,safewrite,pi[1],upbuf,sizeof upbuf);
+  if (substdio_put(&ssauth,user.s,user.len) == -1) die_write();
+  if (substdio_put(&ssauth,pass.s,pass.len) == -1) die_write();
+  if (substdio_put(&ssauth,resp.s,resp.len) == -1) die_write();
+  if (substdio_flush(&ssauth) == -1) die_write();
+
+  close(pi[1]);
+  byte_zero(pass.s,pass.len);
+  byte_zero(upbuf,sizeof upbuf);
+  if (wait_pid(&wstat,child) == -1) die_child();
+  if (wait_crashed(wstat)) die_child();
+  if (wait_exitcode(wstat)) {
+    sleep(ctl_auth_delay); /* wait seconds, defined @ control/auth/delay */
+    return ERR_AUTH_FAILED;
+  } /* bad auth */
+
+  /* qmail-pop3d handles it self */
+  if (auth_for != MODE_SMTPD) return 0;
+
+  /* qmail-smtpd auth: */
+  if (method == METHOD_DIGEST_MD5) {
+    /* digest-md5 requires a special okay response ... */
+    int fd=open_read(resp.s);
+    if (read(fd, &upbuf, 33) != 32) {
+      close(fd);
+      return ERR_AUTH_FAILED;
+    }
+    close(fd); unlink(resp.s);
+    upbuf[32]=0;
+    stralloc_copys(&slop, "rspauth=");
+    stralloc_cats(&slop, upbuf);
+    slop.s[slop.len]=0;
+    b64encode(&resp,&slop);
+    resp.s[resp.len]=0;
+    doserv();out("334 ");out(resp.s);doeol();flush();
+    if (authgetl() < 0) return ERR_AUTH_INPUT;
+  }
+  doserv(); out("235 2.0.0 auth for "); out(user.s); out(" ok, go ahad");
+  doeol(); flush();
+
+  /* yes, good auth done */
+  return 0;
+}
+
+/* user+pass is set */
+int auth_login(char *arg)
+{
+   /* some clients do: 'auth login b64(username)', some not */
+  if (*arg) {
+    if (b64decode(&user,arg,str_len(arg)) != 0)
+      return ERR_AUTH_INPUT;
+  } else {
+    /* Username: */
+    switch (auth_for) {
+      case MODE_SMTPD: out_err("334 VXNlcm5hbWU6"); break;
+      case MODE_POPUP: out_err("+ VXNlcm5hbWU6"); break;
+    }
+    if (authgetl() < 0) return ERR_AUTH_INPUT;
+    if (b64decode(&user,auth.s,auth.len) != 0)
+      return ERR_AUTH_INPUT;
+  }
+
+  /* Password: */
+  switch (auth_for) {
+    case MODE_SMTPD: out_err("334 UGFzc3dvcmQ6"); break;
+    case MODE_POPUP: out_err("+ UGFzc3dvcmQ6"); break;
+  }
+  if (authgetl() < 0) return ERR_AUTH_INPUT;
+  if (b64decode(&pass,auth.s,auth.len) != 0)
+    return ERR_AUTH_INPUT;
+
+  if (!user.len || !pass.len)
+    return ERR_AUTH_INPUT;
+
+  env_put2("SASL", "LOGIN");
+  return authenticate(0);
+}
+
+/* user+pass is set */
+int auth_plain(char *arg)
+{
+  int i=0;
+  char *r_pass, *r_user, x[123];
+
+  doname(); Log("SASL 1("); Log(arg); Log(")\n"); flush();
+  if (*arg) {
+    if (b64decode(&slop,arg,str_len(arg)) != 0)
+      return ERR_AUTH_INPUT;
+  } else {
+    switch (auth_for) {
+      case MODE_SMTPD: out_err("334 "); break;
+      case MODE_POPUP: out_err("+ "); break;
+    }
+
+    if (authgetl() < 0) return ERR_AUTH_INPUT;
+    if (b64decode(&slop,auth.s,auth.len) != 0)
+      return ERR_AUTH_INPUT;
+  }
+
+  if (!stralloc_0(&slop)) die_nomem();
+  doname(); Log("SASL slop("); Logn(slop.s, slop.len); Log(")\n"); flush();
+
+  /* ignore authorize-id */
+  while (slop.s[i++]) {
+    if (i >= slop.len) {
+      return ERR_AUTH_INPUT;
+    }
+  }
+
+  r_user = slop.s + i;
+  doname(); Log("SASL user("); Log(r_user); Log(")\n"); flush();
+  if (!stralloc_copys(&user, r_user)) die_nomem();
+  while (slop.s[i++]) {
+    if (i >= slop.len) {
+      return ERR_AUTH_INPUT;
+    }
+  }
+
+  r_pass = slop.s + i;
+  doname(); Log("SASL pass("); Log(r_pass); Log(")\n"); flush();
+  if (!stralloc_copys(&pass, r_pass)) die_nomem();
+  while (slop.s[i++]) {
+    if (i >= slop.len) {
+      return ERR_AUTH_INPUT;
+    }
+  }
+
+  if (!pass.len || !user.len)
+    return ERR_AUTH_INPUT;
+
+  env_put2("SASL", "PLAIN");
+  return authenticate(0);
+}
+
+/* user+resp is set */
+int auth_cram(char *arg)
+{
+  int i;
+  char *s;
+
+  dounique();
+  if (!stralloc_copys(&pass,"<")) die_nomem();
+  if (!stralloc_cats(&pass,unique)) die_nomem();
+  if (!stralloc_cats(&pass,hostname)) die_nomem();
+  if (!stralloc_cats(&pass,">")) die_nomem();
+  if (b64encode(&slop,&pass) != 0) die_nomem();
+  if (!stralloc_0(&slop)) die_nomem();
+
+  doserv();
+  switch (auth_for) {
+    case MODE_SMTPD: out("334 "); break;
+    case MODE_POPUP: out("+ "); break;
+  }
+  out(slop.s); doeol(); flush();
+
+  if (authgetl() < 0) return ERR_AUTH_INPUT;
+  if (b64decode(&slop,auth.s,auth.len) != 0) return ERR_AUTH_INPUT;
+  if (!stralloc_0(&slop)) die_nomem();
+
+  i = str_chr(slop.s,' ');
+  s = slop.s + i;
+  while (*s == ' ') ++s;
+  slop.s[i] = 0;
+  if (!stralloc_copys(&user,slop.s)) die_nomem();
+  if (!stralloc_copys(&resp,s)) die_nomem();
+
+  if (!user.len || !resp.len) return ERR_AUTH_INPUT;
+  return authenticate(0);
+}
+
+int auth_cram_md5(char *arg) {
+  env_put2("SASL", "CRAM-MD5");
+  return auth_cram(arg);
+}
+
+int auth_cram_sha1(char *arg) {
+  env_put2("SASL", "CRAM-SHA1");
+  return auth_cram(arg);
+}
+
+int auth_cram_rmd(char *arg) {
+  env_put2("SASL", "CRAM-RIPEMD");
+  return auth_cram(arg);
+}
+
+/* parse digest response */
+unsigned int scan_response(stralloc *dst, stralloc *src, const char *search) {
+  char *x=src->s;
+  int slen=strlen(search);
+  int i, len;
+
+  if (!stralloc_copys(dst,"")) die_nomem();
+  for (i=0; src->len>i+slen; i+=str_chr(x+i, ',')+1) {
+    char *s=x+i;
+    if (case_diffb(s, slen, search) == 0) {
+      s+=slen; /* skip name */
+      if (*s++ != '=') return 0; /* has to be here! */
+      if (*s == '"') { /* var="value" */
+        s++;
+        len=str_chr(s, '"');
+        if (!len) return 0;
+        if (!stralloc_catb(dst, s, len)) die_nomem();
+      } else { /* var=value */
+        len=str_chr(s, ',');
+        if (!len) str_len(s); /* should be the end */
+        if (!stralloc_catb(dst, s, len)) die_nomem();
+      }
+      return dst->len;
+    }
+  }
+  return 0;
+}
+
+/* rfc 2831
+ *
+ * sets all 3 variables: user\0pass\0resp\0
+ */
+#define QOP_AUTH      1
+#define QOP_AUTH_INT  2
+#define QOP_AUTH_CONF 3
+int auth_digest_md5(char *arg)
+{
+  unsigned char digest[20], encrypted[41];
+  char *x=encrypted;
+  int i,fd,qop=1;
+  stralloc tmp = {0};
+  stralloc nonce = {0};
+
+  /* user+pass+resp are allready empty */
+  if (!stralloc_copys(&slop,"")) die_nomem();
+
+  dounique(); /* create nonce */
+  hmac_sha1(unique, unique+3, digest); /* should be enough :) */
+  for (i=0; i<20; i++) {
+    *x = hextab[digest[i]/16]; ++x;
+    *x = hextab[digest[i]%16]; ++x;
+  }
+  *x=0;
+
+  if (!stralloc_copys(&tmp, encrypted)) die_nomem();
+  if (b64encode(&nonce,&tmp) != 0) die_nomem();
+  if (!stralloc_cats(&slop,"realm=\"")) die_nomem();
+  if (!stralloc_cats(&slop,hostname)) die_nomem();
+  if (!stralloc_cats(&slop,"\",nonce=\"")) die_nomem();
+  if (!stralloc_cat(&slop,&nonce)) die_nomem();
+  if (!stralloc_cats(&slop,"\",qop=\"auth\"")) die_nomem();
+  if (!stralloc_cats(&slop,",algorithm=md5-sess")) die_nomem();
+  if (!stralloc_0(&slop)) die_nomem();
+  if (b64encode(&tmp,&slop) != 0) die_nomem();
+
+  /* send digest-challenge */
+  doname(); Log("SASL: we send("); Log(slop.s); Log(")\n"); flush();
+  doserv();
+  switch (auth_for) {
+    case MODE_SMTPD: out("334 "); break;
+    case MODE_POPUP: out("+ "); break;
+  }
+  outn(tmp.s,tmp.len); doeol(); flush();
+
+  /* get digest-response */
+  if (authgetl() < 0) return ERR_AUTH_INPUT;
+  if (b64decode(&slop,auth.s,auth.len) != 0) return ERR_AUTH_INPUT;
+  if (!stralloc_0(&slop)) die_nomem();
+  doname(); Log("SASL we got("); Log(slop.s); Log(")\n"); flush();
+
+  /* scan slop for all required fields, fill resp for later auth.  */
+  if (scan_response(&user,&slop, "username") == 0) return ERR_AUTH_INPUT;
+
+  if (scan_response(&tmp,&slop,  "digest-uri") == 0) return ERR_AUTH_INPUT;
+  if (!stralloc_cats(&resp, "digest-uri=")) die_nomem();
+  if (!stralloc_cat(&resp, &tmp)) die_nomem();
+
+  /* check nc field */
+  if (scan_response(&tmp,&slop, "nc") == 0) return ERR_AUTH_INPUT;
+  if (tmp.len != 8) return ERR_AUTH_INPUT;
+  if (case_diffb("00000001", 8, tmp.s) != 0) return ERR_AUTH_INPUT;
+  if (!stralloc_cats(&resp, "\nnc=")) die_nomem();
+  if (!stralloc_cat(&resp, &tmp)) die_nomem();
+
+  /* check nonce */
+  if (scan_response(&tmp,&slop, "nonce") == 0) return ERR_AUTH_INPUT;
+  if (tmp.len != nonce.len) return ERR_AUTH_INPUT;
+  if (case_diffb(nonce.s, tmp.len, tmp.s) != 0) return ERR_AUTH_INPUT;
+  if (!stralloc_cats(&resp, "\nnonce=")) die_nomem();
+  if (!stralloc_cat(&resp, &tmp)) die_nomem();
+
+  /* check cnonce */
+  if (scan_response(&tmp,&slop,  "cnonce") == 0) return ERR_AUTH_INPUT;
+  if (!stralloc_cats(&resp, "\ncnonce=")) die_nomem();
+  if (!stralloc_cat(&resp, &tmp)) die_nomem();
+
+  /* check qop */
+  if (scan_response(&tmp,&slop, "qop") == 0) return ERR_AUTH_INPUT;
+  switch (tmp.len) {
+    case 4: qop=1; if (case_diffb("auth", 4, tmp.s) != 0) return ERR_AUTH_INPUT; break;
+    case 8: qop=2; if (case_diffb("auth-int", 8, tmp.s) != 0) return ERR_AUTH_INPUT; break;
+    case 9: qop=3; if (case_diffb("auth-conf", 9, tmp.s) != 0) return ERR_AUTH_INPUT; break;
+    default: return ERR_AUTH_INPUT;
+  }
+  if (!stralloc_cats(&resp, "\nqop=")) die_nomem();
+  if (!stralloc_cat(&resp, &tmp)) die_nomem();
+
+  /* xxx: todo / check realm against control/realms or so ?! */
+  if (scan_response(&tmp,&slop, "realm") == 0) return ERR_AUTH_INPUT;
+//  i=strlen(hostname);
+//  if (tmp.len != i) return ERR_AUTH_INPUT;
+//  if (case_diffb(hostname, i, tmp.s) != 0) return ERR_AUTH_INPUT;
+  if (!stralloc_cats(&resp, "\nrealm=")) die_nomem();
+  if (!stralloc_cat(&resp, &tmp)) die_nomem();
+
+  /* check response */
+  if (scan_response(&pass,&slop, "response") == 0) return ERR_AUTH_INPUT;
+  if (pass.len != 32) return ERR_AUTH_INPUT;
+
+  /* user=username
+   * pass=response (md5 hash = 32)
+   * resp=authfile (with all required vars for the checkpassword utility)
+   *      -> nc,qop,realm,nonce,cnonce,digesturi
+   *
+   *             a1 = md5(user:realm:pass) : nonce : cnonce
+   * qop=auth:   a2 = 'AUTHENTICATE' : digesturi
+   * qop=auth-*: a2 = 'AUTHENTICATE' : digesturi : '00000000000000000000000000000000'
+   * resp = md5(a1) + nonce + nc + conce + qop + md5(a2)
+   */
+
+  if (!stralloc_copys(&tmp,"/var/qmail/authdir/")) die_nomem();
+  if (!stralloc_cat(&tmp, &pass)) die_nomem();
+  if (!stralloc_0(&tmp)) die_nomem();
+
+  if ((fd=open_trunc(tmp.s)) < 0) die_child();
+  if (write(fd, resp.s, resp.len) != resp.len) die_child();
+  if (close(fd) < 0) die_child();
+  if (!stralloc_copy(&resp,&tmp)) die_nomem();
+
+  /* - we call now checkqpasswd
+   * - it reads needed variables from in resp.s given filename
+   * - it checks validity
+   */
+  if (!user.len || !pass.len || !resp.len) return ERR_AUTH_INPUT;
+  env_put2("SASL", "DIGEST-MD5");
+
+  return authenticate(1);
+}
diff -urN qmail-1.03-vanilla/qmail-sasl.h qmail-1.03-md24/qmail-sasl.h
--- qmail-1.03-vanilla/qmail-sasl.h	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-md24/qmail-sasl.h	2007-07-29 10:18:00.000000000 +0200
@@ -0,0 +1,75 @@
+#include <unistd.h>
+
+#include "byte.h"
+#include "base64.h"
+#include "fd.h"
+#include "fmt.h"
+#include "str.h"
+#include "wait.h"
+#include "substdio.h"
+#include "open.h"
+#include "exit.h"
+#include "fork.h"
+#include "error.h"
+#include "tcpto.h"
+#include "now.h"
+#include "sig.h"
+#include "case.h"
+#include "env.h"
+#include "out_log.h"
+#include "hmac_sha1.h"
+#include "stralloc.h"
+
+/* BEGIN have to be defined from extern */
+extern char unique[];
+extern char *hostname;
+extern char **childargs;
+extern substdio ssin;
+
+extern int ctl_log_err;
+extern int *ctl_auth_current;
+
+extern int auth_for;
+#define MODE_UNKNOWN 0
+#define MODE_POPUP   1
+#define MODE_SMTPD   2
+
+extern int safewrite(int fd, char *buf, int len);
+extern int saferead(int fd, char *buf, int len);
+extern int err_noauth();
+extern void die_nomem();
+extern void die_child();
+extern void die_read();
+extern void die_pipe();
+extern void die_fork();
+extern void die_write();
+/* END OF have to be defined */
+
+/* qmail-sasl.h variables */
+#define ERR_AUTH_FAILED 1
+#define ERR_AUTH_INPUT  2
+#define ERR_AUTH_ABORT  3
+extern int ctl_auth_delay; /* standard = 5 */
+
+extern char upbuf[128];
+extern substdio ssauth;
+extern stralloc auth;
+extern stralloc user;
+extern stralloc pass;
+extern stralloc resp;
+extern stralloc slop;
+
+#define SASL_MAX 6
+extern char *sasl[];
+/*  1 */ extern int auth_login(char *arg);
+/*  2 */ extern int auth_plain(char *arg);
+/*  4 */ extern int auth_cram_md5(char *arg);
+/*  8 */ extern int auth_cram_sha1(char *arg);
+/* 16 */ extern int auth_cram_rmd(char *arg);
+/* 32 */ extern int auth_digest_md5(char *arg);
+
+typedef struct {
+  char *text;
+  int  (*fun)();
+} authcmd_t;
+extern authcmd_t authcmds[];
